'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
	Input_missing: custom_error('Missing input', { additional_properties: { http_status_code: 400 } }),
	Unauthenticated: custom_error('Unauthenticated', { additional_properties: { http_status_code: 401 } }),
	Unauthorized: custom_error('Unauthorized', { additional_properties: { http_status_code: 403 } }),
	Access_denied: custom_error('Access denied', { additional_properties: { http_status_code: 403 } }),
	Not_found: custom_error('Not found', { additional_properties: { http_status_code: 404 } }),
	Conflict: custom_error('Conflict', { additional_properties: { http_status_code: 409 } }),
	Unsupported_input_type: custom_error('Unsupported input type', { additional_properties: { http_status_code: 415 } }),
	Input_rejected: custom_error('Input rejected', { additional_properties: { http_status_code: 422 } }),
	Error: custom_error('Server error', { additional_properties: { http_status_code: 500 } })
};


function custom_error(name, _ref) {
	var code = _ref.code;
	var message = _ref.message;
	var lock_message = _ref.lock_message;
	var additional_properties = _ref.additional_properties;

	var Custom_error = function (_Error) {
		(0, _inherits3.default)(Custom_error, _Error);

		function Custom_error(argument) {
			(0, _classCallCheck3.default)(this, Custom_error);

			var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Custom_error).call(this));

			if ((0, _helpers.exists)(code)) {
				_this.code = code;
			}

			if ((0, _helpers.exists)(message)) {
				_this.message = message;
			} else {
				_this.message = name;
			}

			if ((0, _helpers.exists)(argument)) {
				if ((0, _helpers.exists)(argument.code)) {
					_this.code = argument.code;
				}

				if ((0, _helpers.exists)(argument.message)) {
					_this.message = argument.message;
				}

				if (lock_message !== true) {
					_this.message = argument || _this.message;
				}
			}

			_this.name = name;

			if (additional_properties) {
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = (0, _getIterator3.default)((0, _keys2.default)(additional_properties)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var key = _step.value;

						if (_this[key] === undefined) {
							_this[key] = additional_properties[key];
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			}

			if (Error.captureStackTrace) {
				Error.captureStackTrace(_this, Custom_error);
			}
			return _this;
		}

		return Custom_error;
	}(Error);

	return Custom_error;
}
module.exports = exports['default'];
//# sourceMappingURL=errors.js.map