'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = function (_ref) {
	var development = _ref.development;
	var log = _ref.log;
	var html = _ref.html;

	return function () {
		var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(ctx, next) {
			var http_status_code, _render_stack_trace, response_status, response_body;

			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							_context.prev = 0;
							_context.next = 3;
							return next();

						case 3:
							_context.next = 19;
							break;

						case 5:
							_context.prev = 5;
							_context.t0 = _context['catch'](0);
							http_status_code = void 0;


							if ((0, _helpers.exists)(_context.t0.http_status_code)) {
								http_status_code = _context.t0.http_status_code;
							}
							// superagent errors
							// https://github.com/visionmedia/superagent/blob/29ca1fc938b974c6623d9040a044e39dfb272fed/lib/node/response.js#L106
							else if (typeof _context.t0.status === 'number') {
									http_status_code = _context.t0.status;
								}

							if ((0, _helpers.exists)(http_status_code)) {
								// set Http Response status code according to the error's `code`
								ctx.status = http_status_code;

								// set Http Response text according to the error message
								ctx.body = _context.t0.message || 'Internal error';
							} else {
								// log the error, if it's not a normal Api error
								// (prevents log pollution with things like 
								//  `404 User not found` or `401 Not authenticated`)

								// if (error.proxy_error 
								// 	&& options.show_proxy_errors 
								// 	&& options.show_proxy_errors[error.proxy_to] === false)
								// {
								// 	// don't output error to the log
								// }
								// else
								// {
								// 	// for easier debugging
								// 	console.log('(http request failed)')
								// 	log.error(error)
								// }

								log.error(_context.t0, '(http request failed)');

								ctx.status = 500;
								ctx.body = 'Internal error';
							}

							// show error stack trace in development mode for easier debugging

							if (!(development && (!http_status_code || http_status_code === 500 && _context.t0.message === 'Internal Server Error'))) {
								_context.next = 19;
								break;
							}

							_render_stack_trace = render_stack_trace(_context.t0, { html: html });
							response_status = _render_stack_trace.response_status;
							response_body = _render_stack_trace.response_body;

							if (!response_body) {
								_context.next = 19;
								break;
							}

							ctx.status = response_status || http_status_code || 500;
							ctx.body = response_body;
							ctx.type = 'html';

							return _context.abrupt('return');

						case 19:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, this, [[0, 5]]);
		}));

		return function (_x, _x2) {
			return _ref2.apply(this, arguments);
		};
	}();
};

var _printError = require('print-error');

var _helpers = require('../helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function render_stack_trace(error, _ref3) {
	var html = _ref3.html;

	// supports custom `html` for an error
	if (error.html) {
		return { response_status: error.code, response_body: error.html };
	}

	// handle `superagent` errors: if an error response was an html, then just render it
	// https://github.com/visionmedia/superagent/blob/29ca1fc938b974c6623d9040a044e39dfb272fed/lib/node/response.js#L106
	if (typeof error.status === 'number') {
		// if the `superagent` http request returned an html response 
		// (possibly an error stack trace),
		// then just output that stack trace
		if (error.response && error.response.headers['content-type'] && error.response.headers['content-type'].split(';')[0].trim() === 'text/html') {
			return { response_status: error.status, response_body: error.message };
		}
	}

	// if this error has a stack trace then it can be shown

	var stack_trace = void 0;

	if (error.stack) {
		stack_trace = error.stack;
	}
	// `superagent` errors have the `original` property 
	// for storing the initial error
	else if (error.original && error.original.stack) {
			stack_trace = error.original.stack;
		}

	// if this error doesn't have a stack trace - do nothing
	if (!stack_trace) {
		return {};
	}

	try {
		return { response_body: (0, _printError.html)({ stack: stack_trace }, html) };
	} catch (error) {
		console.error(error);
		return { response_status: 500, response_body: error.stack };
	}
}
module.exports = exports['default'];
//# sourceMappingURL=error handler.js.map